<script lang="ts">
import Vue from 'vue';
import {
  SideNavigationVariant,
  NextStep,
  GroupButtons,
} from '../../common/index.vue';
import {
  BySolutionHero,
  BySolutionValueProp,
  BySolutionBenefits,
  BySolutionLink,
  BySolutionIntro,
  BySolutionAccordeon,
  BySolutionCasestudies,
  BySolutionListImage,
  BySolutionShowcase,
} from '../by-solution/index.vue';
import {
  ByIndustryCaseStudies,
  ByIndustryIntro,
  ByIndustrySolutionsBlock,
} from '../by-industry/index.vue';
import { ByIndustryQuotesCarousel } from '../by-industry/quotes-carousel/index.vue';
import { SolutionsHero, SolutionsResourceCards, TierBlock } from '../index.vue';

export default Vue.extend({
  name: 'IndustryTemplate',
  components: {
    TierBlock,
    NextStep,
    BySolutionShowcase,
    BySolutionHero,
    BySolutionValueProp,
    BySolutionBenefits,
    SolutionsResourceCards,
    BySolutionIntro,
    BySolutionAccordeon,
    BySolutionCasestudies,
    BySolutionListImage,
    BySolutionLink,
    SideNavigationVariant,
    SolutionsHero,
    ByIndustryIntro,
    ByIndustryCaseStudies,
    ByIndustryQuotesCarousel,
    ByIndustrySolutionsBlock,
    GroupButtons,
  },
  props: {
    solutions: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <div>
    <component
      :is="component.name"
      v-for="component in solutions.components"
      :key="component.name"
      :data="component.data"
      v-bind="component"
    >
      <slot v-if="component.slot_enabled">
        <component
          :is="subcomponent.name"
          v-for="(subcomponent, item) in component.slot_content"
          :key="item"
          v-bind="subcomponent"
          :offset="subcomponent.offset || component.slot_offset"
        >
          <slot v-if="subcomponent.slot_enabled">
            <component
              :is="contents.name"
              v-for="(contents, subitem) in subcomponent.slot_content"
              :key="subitem"
              :offset="contents.offset || component.slot_offset"
              v-bind="contents"
            />
          </slot>
        </component>
      </slot>
    </component>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss"></style>
